#import "/src/cetz.typ": draw

#import "/src/core/utils.typ": normalize-measure
#import "/src/consts.typ": *

#let name = "boundary"

#let render(x, y, p, bottom) = {
  let m = measure(p.display-name)
  let style = p.resolved-style
  let circle-r = BOUNDARY-HEIGHT / 2
  let y0 = if bottom {
    y - m.height / 1pt - SYM-GAP
  } else {
    y + m.height / 1pt + BOUNDARY-HEIGHT + SYM-GAP
  }
  let x0 = x - BOUNDARY-HEIGHT
  let y1 = y0 - circle-r
  let y2 = y0 - BOUNDARY-HEIGHT

  draw.circle(
    (x + circle-r, y1),
    radius: circle-r,
    fill: style.fill,
    stroke: style.stroke
  )
  draw.line(
    (x0, y0), (x0, y2),
    stroke: style.stroke
  )
  draw.line(
    (x0, y1), (x, y1),
    stroke: style.stroke
  )
  draw.content(
    (x, y),
    p.display-name,
    anchor: if bottom {"north"} else {"base"}
  )
}

#let get-size(par) = {
  let m = normalize-measure(par.display-name)

  // BOUNDARY-HEIGHT * 2pt
  // BOUNDARY-HEIGHT * 1pt + SYM-GAP * 1pt + h

  return m
}

#let default-style = (
  :
)