#import "/src/cetz.typ": draw

#import "/src/core/utils.typ": normalize-measure
#import "/src/consts.typ": *

#let name = "control"

#let render(x, y, p, bottom) = {
  let m = measure(p.display-name)
  let style = p.resolved-style
  let r = CONTROL-HEIGHT / 2
  let y0 = if bottom {
    y - m.height / 1pt - SYM-GAP
  } else {
    y + m.height / 1pt + CONTROL-HEIGHT + SYM-GAP
  }

  draw.circle(
    (x, y0 - r),
    radius: r,
    fill: style.fill,
    stroke: style.stroke
  )
  let s = stroke(style.stroke)
  draw.mark((x, y0), (x - r / 2, y0), symbol: "stealth", fill: s.paint)
  draw.content(
    (x, y),
    p.display-name,
    anchor: if bottom {"north"} else {"base"}
  )
}

#let get-size(par) = {
  let m = normalize-measure(par.display-name)

  // CONTROL-HEIGHT * 1pt
  // CONTROL-HEIGHT * 1pt + SYM-GAP * 1pt + h

  return m
}

#let default-style = (
  :
)